!*****************************************************************************!
!* 
!*      $RCSfile: Flux_roe.f90,v $
!*
!*      $Revision: 1.4 $
!*
!*      $Date: 2004/01/29 09:58:07 $
!*
!*      $Author: iagmidu $
!*
!*****************************************************************************!

MODULE flux_roe_mod
  !--------------------------------------------------------------------------
  IMPLICIT NONE
  PRIVATE
  !----------------------------------------------------------------------------
  INTERFACE flux_roe
     MODULE PROCEDURE flux_roe
  END INTERFACE
  !----------------------------------------------------------------------------

  PUBLIC  :: flux_roe

CONTAINS

  SUBROUTINE flux_roe( gamma,                     &
       rho_l, rho_r, vn_l , vn_r, &
       vt_l , vt_r , p_l  , p_r , &
       flux_side                   )
    !--------------------------------------------------------------------------
    IMPLICIT NONE
    !--------------------------------------------------------------------------
    !argument list declaration
    REAL         :: gamma
    REAL         :: rho_l, rho_r
    REAL         :: vn_l , vn_r
    REAL         :: vt_l , vt_r
    REAL         :: p_l  , p_r
    REAL         :: flux_side(4)
    !local variable declaration
    REAL         :: e_r,e_l,H_r, H_l
    REAL         :: sqrt_rho_r, sqrt_rho_l
    REAL         :: vn_quer,vt_quer,H_quer,c_quer
    REAL         :: a1,a2,a3,a4
    REAL         :: r1(4),r2(4),r3(4),r4(4)
    REAL         :: delta_rho,delta_m1,delta_m2,delta_e,delta_eq
    REAL         :: gamma1,gamma2,gamma3,gamma4
    REAL         :: f1_r(4),f1_l(4)
    !--------------------------------------------------------------------------
    INTENT(IN)   :: gamma,                     &
         rho_l, rho_r, vn_l , vn_r, &
         vt_l , vt_r , p_l  , p_r 
    INTENT(OUT)  :: flux_side    
    !--------------------------------------------------------------------------

    ! Calculate left/right energy and enthalpy








    ! Calculate sqrt(rho)




    ! Calculate Roe mean values







    ! Calculate mean eigenvalues






    ! Calculate mean eigenvectors





















    ! Calculate differences







    ! Calculate factors gamma1,...,gamma4









    ! Calculalte the physical fluxes











    ! Calculate Roe fluxes







    RETURN
  END SUBROUTINE flux_roe

END MODULE flux_roe_mod
