!*****************************************************************************!
!* 
!*      $RCSfile: Flux_hlle.f90,v $
!*
!*      $Revision: 1.5 $
!*
!*      $Date: 2004/01/29 11:10:54 $
!*
!*      $Author: iagmidu $
!*
!*****************************************************************************!

MODULE flux_hlle_mod
  !--------------------------------------------------------------------------
  IMPLICIT NONE
  PRIVATE
  !----------------------------------------------------------------------------
  INTERFACE flux_hlle
     MODULE PROCEDURE flux_hlle
  END INTERFACE
  !----------------------------------------------------------------------------

  PUBLIC  :: flux_hlle

CONTAINS

  SUBROUTINE flux_hlle( gamma,                     &
                           rho_l, rho_r, vn_l , vn_r, &
                           vt_l , vt_r , p_l  , p_r , &
                           flux_side                   )

    !--------------------------------------------------------------------------
    IMPLICIT NONE


    !argument list declaration
    REAL         :: gamma
    REAL         :: rho_l, rho_r
    REAL         :: vn_l , vn_r
    REAL         :: vt_l , vt_r
    REAL         :: p_l  , p_r
    REAL         :: flux_side(4)

    !local variable declaration
    REAL         :: fl(4),fr(4),ul(4),ur(4)
    REAL         :: c_l,c_r,H_l,H_r,kin
    REAL         :: um, vm, Hm, cm
    REAL         :: arp, alm
    !--------------------------------------------------------------------------
    INTENT(IN)   :: gamma,                     &
                    rho_l, rho_r, vn_l , vn_r, &
                    vt_l , vt_r , p_l  , p_r 
    INTENT(OUT)  :: flux_side    
    !--------------------------------------------------------------------------
    ! Flux in left cell




    ! Flux in right cell




    ! Left conservative state vector




    ! Right conservative state vector




    ! Calculation of sound speeds


    ! Left enthalpy


    ! Right enthalpy


    ! Roe mean values




    ! Signal speeds


    ! HLLE-Flux

    RETURN
  END SUBROUTINE flux_hlle

END MODULE flux_hlle_mod
