!*****************************************************************************!
!* 
!*      $RCSfile: Flux_steger_warming.f90,v $
!*
!*      $Revision: 1.2 $
!*
!*      $Date: 2003/01/13 16:48:44 $
!*
!*      $Author: iagmidu $
!*
!*****************************************************************************!

MODULE flux_steger_warming_mod
  !--------------------------------------------------------------------------
  IMPLICIT NONE
  PRIVATE
  !----------------------------------------------------------------------------
  INTERFACE flux_steger_warming
     MODULE PROCEDURE flux_steger_warming
  END INTERFACE
  !----------------------------------------------------------------------------

  PUBLIC  :: flux_steger_warming

CONTAINS

  SUBROUTINE flux_steger_warming( gamma,                     &
                           rho_l, rho_r, vn_l , vn_r, &
                           vt_l , vt_r , p_l  , p_r , &
                           flux_side                   )

    !--------------------------------------------------------------------------
    IMPLICIT NONE
    !--------------------------------------------------------------------------

    !argument list declaration
    REAL         :: gamma
    REAL         :: rho_l, rho_r
    REAL         :: vn_l , vn_r
    REAL         :: vt_l , vt_r
    REAL         :: p_l  , p_r
    REAL         :: flux_side(4)

    !local variable declaration
    REAL         :: c_l,c_r
    REAL         :: ap(4), am(4), a_l(4), a_r(4)
    REAL         :: fp(4), fm(4)
    INTEGER      :: i
    !--------------------------------------------------------------------------
    INTENT(IN)   :: gamma,                     &
                    rho_l, rho_r, vn_l , vn_r, &
                    vt_l , vt_r , p_l  , p_r 
    INTENT(OUT)  :: flux_side    
    !--------------------------------------------------------------------------
    ! Calculation of sound speeds


    ! Calculation of eigenvalues








    ! Calculation of positive and negative eigenvalues




    ! Positive flux from left to right





    ! Negative flux from right to left





    ! Final flux

    RETURN
  END SUBROUTINE flux_steger_warming

END MODULE flux_steger_warming_mod
